#!/usr/bin/perl

$ACTIVE_FILE = "/home/news/active";

$TM_SEC = 0;		# Used for indexing into localtime() list.
$TM_MIN = 1;
$TM_HOUR = 2;
$TM_MDAY = 3;
$TM_MON = 4;
$TM_YEAR = 5;
$TM_WDAY = 6;
$TM_YDAY = 7;
$TM_ISDST = 8;

$PRI_SIZE = 0;		# Size of articles in primary newsgroup.
$PRI_COUNT = 1;		# Count...
$SEC_SIZE = 2;		# Size of articles in cross-posted newsgroup.
$SEC_COUNT = 3;		# Count...
# $ART_GROUP = 4;

$FROM_SIZE = 0;		# Size of articles from feed.
$FROM_COUNT = 1;	# Count...
# $FROM_HOST = 2;

$hour_0000 = 0;
$hour_5959 = 0;

$dataflag = 0;

sub dumpdata {
    if ($dataflag == 1) {
	my $yymmdd = sprintf("%02d%02d%02d",
		$colldate[$TM_YEAR],
		$colldate[$TM_MON] + 1,
		$colldate[$TM_MDAY]);
	my $hhmm = sprintf("%02d00", $colldate[$TM_HOUR]);

	my $logname = "fromhour.$yymmdd.$hhmm.$SUFFIX";
	open (STATO,">$logname") ||
		die "Cannot create output statfile \"$logname\"\n";
	foreach $fromhost (keys %fromstats) {
	    printf STATO ("$yymmdd %d %d %d %s\n", $colldate[$TM_HOUR],
			$fromstats{$fromhost}[$FROM_SIZE],
			$fromstats{$fromhost}[$FROM_COUNT],
			$fromhost);
	}
	close STATO;

	my $logname = "artshour.$yymmdd.$hhmm.$SUFFIX";
	open (STATO,">$logname") ||
		die "Cannot create output statfile \"$logname\"\n";
	printf STATO ("$yymmdd %d %d %d %d %d *Invalid-Newsgroup*\n",
		$colldate[$TM_HOUR],
		$pri_junk_size, $pri_junk_count,
		$sec_junk_size, $sec_junk_count);
	foreach $group (keys %artstats) {
	    printf STATO ("$yymmdd %d %d %d %d %d %s\n", $colldate[$TM_HOUR],
			$artstats{$group}[$PRI_SIZE],
			$artstats{$group}[$PRI_COUNT],
			$artstats{$group}[$SEC_SIZE],
			$artstats{$group}[$SEC_COUNT],
			$group);
	}
	close STATO;
    }
    %fromstats = ();
    %artstats = ();
    $pri_junk_size = 0;		# for invalid groups
    $pri_junk_count = 0;
    $sec_junk_size = 0;
    $sec_junk_count = 0;
    $dataflag = 0;

    $colldate[$TM_ISDST] = 0;	# Keep perl -w happy.
    $colldate[$TM_YDAY]  = 0;	#  I know that I don't
    $colldate[$TM_WDAY]  = 0;	#   need these.

    @colldate = localtime($artdate);
    $hour_0000 = $artdate - ($colldate[$TM_MIN] * 60 + $colldate[$TM_SEC]);
    $hour_5959 = $hour_0000 + 3599;
}


open(ACTIVE,$ACTIVE_FILE) || die "Cannot open active file\n";
while (<ACTIVE>) {
    @fields = split;
    $validgroup{$fields[0]} = 1;
}
close (ACTIVE);

#    $results = %validgroup;
#    print "$results\n";


foreach $INPUT (@ARGV) {
    if ($INPUT =~ /^news\.\.flow\.([0-9]{10})$/) {
	$SUFFIX = $1;
    }
    else {
	die "Invalid input file \"$INPUT\"\n";
    }

    open(INPUT,$INPUT) || die "Cannot open input file \"$INPUT\"\n";

    while (<INPUT>) {
	($artsize, $artdate, $artfrom, $artgroups) = split;

	if ($artdate < $hour_0000 or $artdate > $hour_5959) {
	    &dumpdata;
	}

	$dataflag = 1;
	$fromstats{$artfrom}[$FROM_SIZE] += $artsize;
	$fromstats{$artfrom}[$FROM_COUNT] += 1;

	@testgroups = split (",", $artgroups);
	$group = shift @testgroups;
	if ($validgroup{$group}) {
	    $artstats{$group}[$PRI_SIZE] += $artsize;
	    $artstats{$group}[$PRI_COUNT] += 1;
	}
	else {
	    $pri_junk_size += $artsize;
	    $pri_junk_count += 1;
	}
	foreach $group (@testgroups) {
	    if ($validgroup{$group}) {
		$artstats{$group}[$SEC_SIZE] += $artsize;
		$artstats{$group}[$SEC_COUNT] += 1;
	    }
	    else {
		$sec_junk_size += $artsize;
		$sec_junk_count += 1;
	    }
	}
    }

&dumpdata;
unlink $INPUT;

}
exit;
