#! /bin/sh

##  =()<. @<_PATH_SHELLVARS>@>()=
. /home/news/innshellvars

export NEWSFEEDS

YYMMDD=`date +%y%m%d`

PROGNAME=`basename $0`
FLOWDAY=$BATCH/flow/day
WEBREPTDIR=/usr/mylocal/httpd-1.5.1/htdocs/news
TEMPLATE=/usr/mylocal/httpd-1.5.1/misc
TOPARTCOUNT=top.art.count
TOPARTLINES=25
FROMFEEDREPT=from.feed.rept
ARTSPERDAY=arts.per.day
KEEP=7

cd $FLOWDAY

REPTDATE=`ls | grep artsday | tail -1 | sed s/artsday.//`
REPTYY=`expr $REPTDATE : "^\([0-9][0-9]\)"`

[ -f fromday.$REPTDATE ] && {
    flowfromrept.pl -n fromday.$REPTDATE > $WEBREPTDIR/$FROMFEEDREPT.$REPTDATE
    [ -f $WEBREPTDIR/$ARTSPERDAY.$REPTYY ] || {
	echo `hostname` > $WEBREPTDIR/$ARTSPERDAY.$REPTYY
    }
    web.arts.per.day.pl fromday.$REPTDATE >> $WEBREPTDIR/$ARTSPERDAY.$REPTYY
}

[ -f artsday.$REPTDATE ] && {
    sort -n -r +2 +5 artsday.$REPTDATE |
	head -$TOPARTLINES |
	web.top.art.count.pl > $WEBREPTDIR/$TOPARTCOUNT.$REPTDATE
}

cd $WEBREPTDIR
rm -f *~
for FILE in $FROMFEEDREPT $TOPARTCOUNT
do
    PUNTABLE=`ls | grep "^${FILE}\.[0-9][0-9][0-9][0-9][0-9][0-9]" |
	sort -r |
	sed 1,${KEEP}d`
    [ -n "$PUNTABLE" ] && rm -f $PUNTABLE
done

WFILE=/usr/mylocal/httpd-1.5.1/htdocs/news/index.html.$$

cat $TEMPLATE/index.html.00 > $WFILE
for FILE in `ls | grep "^$ARTSPERDAY"`
do
    Y=`expr $FILE : "^$ARTSPERDAY\.\([0-9][0-9]\)"`
    echo '    <li> <a href="'"$FILE"'">'"'$Y</a>" >> $WFILE
done

cat $TEMPLATE/index.html.01 >> $WFILE
for FILE in `ls | grep "^$FROMFEEDREPT"`
do
    Y=`expr $FILE : "^$FROMFEEDREPT\.\([0-9][0-9]\)[0-9][0-9][0-9][0-9]"`
    M=`expr $FILE : "^$FROMFEEDREPT\.[0-9][0-9]\([0-9][0-9]\)[0-9][0-9]"`
    D=`expr $FILE : "^$FROMFEEDREPT\.[0-9][0-9][0-9][0-9]\([0-9][0-9]\)"`
    case $M in
	01) MO=Jan ;;
	02) MO=Feb ;;
	03) MO=Mar ;;
	04) MO=Apr ;;
	05) MO=May ;;
	06) MO=Jun ;;
	07) MO=Jul ;;
	08) MO=Aug ;;
	09) MO=Sep ;;
	10) MO=Oct ;;
	11) MO=Nov ;;
	12) MO=Dec ;;
    esac
    echo '    <li> <a href="'"$FILE"'">'"$D-$MO-$Y</a>" >> $WFILE
done

cat $TEMPLATE/index.html.02 >> $WFILE
for FILE in `ls | grep "^$TOPARTCOUNT"`
do
    Y=`expr $FILE : "^$TOPARTCOUNT\.\([0-9][0-9]\)[0-9][0-9][0-9][0-9]"`
    M=`expr $FILE : "^$TOPARTCOUNT\.[0-9][0-9]\([0-9][0-9]\)[0-9][0-9]"`
    D=`expr $FILE : "^$TOPARTCOUNT\.[0-9][0-9][0-9][0-9]\([0-9][0-9]\)"`
    case $M in
	01) MO=Jan ;;
	02) MO=Feb ;;
	03) MO=Mar ;;
	04) MO=Apr ;;
	05) MO=May ;;
	06) MO=Jun ;;
	07) MO=Jul ;;
	08) MO=Aug ;;
	09) MO=Sep ;;
	10) MO=Oct ;;
	11) MO=Nov ;;
	12) MO=Dec ;;
    esac
    echo '    <li> <a href="'"$FILE"'">'"$D-$MO-$Y</a>" >> $WFILE
done

cat $TEMPLATE/index.html.03 >> $WFILE

mv $WFILE $WEBREPTDIR/index.html
